      subroutine average
      use work_arrays
      implicit integer (i-n)
      implicit double precision (a-h,o-z)
c      include 'para.inc'
c
c
c      ir1 = isub1
c      ir2 = iden1
c      ir3 = isub2
c      ir4 = iden2
c
      istr = 1
      iend = iall
c      iend = ir1 + ir2 + ir3 + ir4
ccc   avr_sc
c     1.tnw_cls 2.tnw_sub 3.uk_cls 4.uk_sub
ccc avr_at
c     1.ekin 2.vij
c
      rave = 1.0d0/real(navestep)
c  temperatures and potential energies at each region
      avr_sc(1) = avr_sc(1) + tnw(1)*rave
      avr_sc(2) = avr_sc(2) + tnw(2)*rave
      avr_sc(3) = avr_sc(3) + tnw(3)*rave
      avr_sc(4) = avr_sc(4) + tnw(4)*rave
      avr_sc(5) = avr_sc(5) + uk(1)*rave
      avr_sc(6) = avr_sc(6) + uk(2)*rave
      avr_sc(7) = avr_sc(7) + uk(3)*rave
      avr_sc(8) = avr_sc(8) + uk(4)*rave
c
c   avr_at(j,*) j=1:kinetic energy  2:potential energy 3:sigma_x 
c                 4:sigma_y 5:sigma_z 6:sigma_xy 7:sigma_xz 8:sigma_yz 
c                 9:x(i) 10:y(i) 11:z(i)
      do 10 i = 1, iend
        avr_at(1,i) =  avr_at(1,i) + ekin(i)*rave ! kinetic energy
        avr_at(2,i) =  avr_at(2,i) + vij(i)*rave  ! potential energy
        avr_at(3,i) =  avr_at(3,i) + stress(1,i)*rave ! sigma_x
        avr_at(4,i) =  avr_at(4,i) + stress(2,i)*rave ! sigma_y
        avr_at(5,i) =  avr_at(5,i) + stress(3,i)*rave ! sigma_z
        avr_at(6,i) =  avr_at(6,i) + stress(6,i)*rave ! sigma_xy
        avr_at(7,i) =  avr_at(7,i) + stress(5,i)*rave ! sigma_xz
        avr_at(8,i) =  avr_at(8,i) + stress(4,i)*rave ! sigma_yz
        avr_at(9,i)  =  avr_at(9,i)  + x(i)*rave ! x(i)
        avr_at(10,i) =  avr_at(10,i) + y(i)*rave ! y(i)
        avr_at(11,i) =  avr_at(11,i) + z(i)*rave ! z(i)
 10   continue
c
c
c      if ( mod(nstep,navestep).eq.0) then
c         write(25,'(8e12.3)')(avr_sc(i),i=1,8)
c      do i = 1, iend
c         write(26,'(8e15.7)')(avr_at(j,i),j=1,8)
c      enddo
c      avr_sc=0.0d0
c      avr_at=0.0d0
c      endif
c     
      return
      end
