      SUBROUTINE DATA_MD
      use fem_arrays
      use connect
      implicit integer (i-n)
      implicit double precision (a-h,o-z)
c*************************************************************
c  MD DATA --> FEM DATA
c    ux(im) ---> IDIS(NTDIS0+in),UB(NTDIS0+in)
c      im = ncor(i,1)  IDIS = freedom of ncor(i,3)-th node
c                                 in this case (x,y)limited
c     NTDIS0 = NTDIS - NR2*2
c  substract
c    internal displacement  :  uz = d_con * eps(im,1,2)
c                           :  uy = d_con * eps(im,1,3)
c                           :  ux = d_con * eps(im,2,3)
c*************************************************************
c
cccc   MD-DISPLACEMENT --> FEM BOUNDARY CONDITION
c
c       write(6,*)ntdis,ntdis0
c
       do 20 i = 1,nr2
          nnode = ncor2(i,4)
          natom = ncor2(i,1)
          pm    = ncor2(i,2)
c          write(6,*)natom
cccc node number ---> freedom number
          nfreex = (nnode-1)*IDIM + 1
          nfreey = (nnode-1)*IDIM + 2
          nfreez = (nnode)*IDIM
cccc constrain x-y freedom
          I1 = (I-1)*3 + 1
          I2 = (I-1)*3 + 2
          I3 =  I*3
          IDIS(NTDIS0+I1) = nfreex
          IDIS(NTDIS0+I2) = nfreey
          IDIS(NTDIS0+I3) = nfreez
cccc internal displacement (ignore z-direction) +-??
cccc  u_i = d_ijk * ep_jk
c          pm = ncor2(i,2)
c          write(6,*)'Plus-Minus',pm
            uzi = -pm * d_con * atomep(natom,4) 
            uyi = -pm * d_con * atomep(natom,5) 
            uxi = -pm * d_con * atomep(natom,6) 
cccc displacements
            UB(NTDIS0+I1) = ux(natom)-uxi
            UB(NTDIS0+I2) = uy(natom)-uyi
            UB(NTDIS0+I3) = uz(natom)-uzi
c      write(343,*)'NODE',nnode,'-->UX=',ux(natom)-uxi,nfreex
c      write(343,*)'NODE',nnode,'-->UY=',uy(natom)-uyi,nfreey
c      write(343,*)'NODE',nnode,'-->UZ=',uz(natom)-uzi,nfreez
 20    continue
c
        return
        end

