      SUBROUTINE DATA_NCOR
      use fem_arrays
      use connect
      implicit integer (i-n)
      implicit double precision (a-h,o-z)
cccc local array for delocate
      dimension idis_del(ntdis)
      dimension ub_del(ntdis)
c*************************************************************
c  MD DATA --> FEM DATA
c    ux(im) ---> IDIS(NTDIS+in),UB(NTDIS+in)
c      im = ncor(i,1)  IDIS = freedom of ncor(i,3)-th node
c                                 in this case (x,y)limited
c  substract
c    internal displacement  :  uz = d_con * eps(im,1,2)
c                           :  uy = d_con * eps(im,1,3)
c                           :  ux = d_con * eps(im,2,3)
c*************************************************************
cccc   MD-DISPLACEMENT --> FEM BOUNDARY CONDITION
c      open(33,file='ncor2.dat')
      open(33,file=fnum(4),status='unknown')
c
      nr2 = 0
      do  
        read(33,'(5i5)',end=998)n11,n22,n33,n44,n55
        nr2 = nr2 + 1
      enddo
 998  continue
      close(33)
c
      allocate(ncor2(nr2,5))
c
      open(33,file=fnum(4),status='unknown')
c      open(33,file='ncor2.dat')
      do i = 1,nr2
        read(33,'(5i5)')(ncor2(i,k),k=1,5)
      enddo
      close(33)
c
ccc 2--> x,y direction
ccc 3--> x,y direction
       do i = 1,ntdis
          idis_del(i) = idis(i)
          ub_del(i) = ub(i)
       enddo
c
       deallocate(idis)
       deallocate(ub)
c
       ntdis0 = ntdis
       ntdis = ntdis + 3*nr2
       allocate(idis(ntdis))
       allocate(ub(ntdis))
c
c       ntdis1 = ntdis + 3*nr2
c
c       allocate(idis(ntdis1))
c       allocate(ub(ntdis1))
c
       do i = 1,ntdis0
          idis(i) = idis_del(i)
          ub(i)   = ub_del(i)
       enddo
c
c       ntdis = ntdis + 3*nr2
c        
c------------------------------------------     
c  ncor(i,1) : atom number
c  ncor(i,3) : node number
c  constrain --> x,y direction
c------------------------------------------
c
c      open(34,file='ncor3.dat')
      open(34,file=fnum(5),status='unknown')
c
      nr3 = 0
      do 
      read(34,'(5i5,3e15.7)',end=999)n11,n22,n33,n44,n55,p11,p22,p33
      nr3 = nr3 + 1
      enddo
 999  continue
      close(34)
c
      allocate(ncor(nr3,5),pcor(nr3,3))
      open(34,file=fnum(5),status='unknown')
c      open(34,file='ncor3.dat')
c
      do i = 1,nr3
      read(34,'(5i5,3e15.7)',end=999)
     &         (ncor(i,k),k=1,5),(pcor(i,kk),kk=1,3)
      enddo

c      write(6,*)'region2=',nr2,'  region3=',nr3
      close(34)
c
      return
      end

