      subroutine energy
c     (iall,nkind,vx,vy,vz,vxi,vyi,vzi,vij,ekin)
      use work_arrays
      implicit integer (i-n)
      implicit double precision (a-h,o-z)
c
c----------------------------------------
c  For epitaxyal growth model      
c----------------------------------------
c
cccc number of atoms in each regions
      ir1 = isub1
      ir2 = iden1
      ir3 = isub2
      ir4 = iden2
c
      istr = 1
      iend = ir1 + ir2 + ir3 + ir4
cccc atomic kinetic energy
      do 10 i=1,iend
       nk1 = nkind(i)
       if (nk1.eq.1) wg_i = wg_si
       if (nk1.eq.2) wg_i = wg_h
       if (nk1.eq.3) wg_i = wg_c
       ekin(i)=(vx(i)*vx(i)+vy(i)*vy(i)+vz(i)*vz(i))*wg_i*0.5d0
 10   continue
c
      vij_all = sum(vij)
cccc temperature of each region
c isub1     
      if (isub1.ne.0) then
      tnw = 0.0d0 ; uk =0.0d0
      ist = 1 ; ien = ir1
      do i = ist,ien
         tnw(1) = tnw(1)   + ekin(i)
         uk(1) = uk(1) + ekin(i) + vij(i)
      end do
         tnw(1) = tnw(1) / real(ir1) / 3.0 * 2.0
      endif
c iden1
      if (iden1.ne.0) then
      ist = ist + ir1 ; ien = ien + ir2
      do i = ist,ien
         tnw(2) = tnw(2)   + ekin(i)
         uk(2) = uk(2) + ekin(i) + vij(i)
      end do
         tnw(2) = tnw(2) / real(ir2) / 3.0 * 2.0
      endif
c isub2
      if (isub2.ne.0) then
      ist = ist + ir2 ; ien = ien + ir3
      do i = ist,ien
         tnw(3) = tnw(3)   + ekin(i)
         uk(3) = uk(3) + ekin(i) + vij(i)
      end do
         tnw(3) = tnw(3) / real(ir3) / 3.0 * 2.0
      endif
c iden2
      if (iden2.ne.0) then
      ist = ist + ir3 ; ien = ien + ir4
      do i = ist,ien
         tnw(4) = tnw(4)   + ekin(i)
         uk(4) = uk(4) + ekin(i) + vij(i)
      end do
         tnw(4) = tnw(4) / real(ir4) / 3.0 * 2.0
      endif
c
c      write(6,*)(tnw(i),i=1,4),itmp,ntemp
c
      if (ir3.ne.0) then
ccccc  For (NVT) ensamble --- temperature scaling for substrate
c   write(6,*)'before scaling',tnw_sub,tf_sub
c  ntemp = 0 --> sqrtemp = 1.0 not scaling
c  ntemp = 1 --> sqrtemp           scaling
ccccc temperature control region  ir3
c      sqrtemp0=sqrt(tf_sub/tnw_sub) 
      sqrtemp0_3=sqrt(tf_sub/tnw(3))
      sqrtemp_3 = real(1-ntemp) * 1.0d0 + real(ntemp) * sqrtemp0_3
c
c      sqrtemp0_4=sqrt(tf_sub/tnw(4))
c      sqrtemp_4 = real(1-ntemp) * 1.0d0 + real(ntemp) * sqrtemp0_4
c
c      write(6,*)'ir1',tf_sub,tnw(1)
c      write(6,*)'ir2',tf_sub,tnw(2)
c      write(6,*)'ir3',tf_sub,tnw(3)
c      write(6,*)'ir4',tf_sub,tnw(4)
c      read(5,*)
c
ccccc region 3 (ir3)
      ist = ir1 + ir2 + 1 ; ien = ir1 + ir2 + ir3
      do i= ist,ien
         vxi(i)=vxi(i)*sqrtemp_3
         vyi(i)=vyi(i)*sqrtemp_3
         vzi(i)=vzi(i)*sqrtemp_3
         vx(i)=hmat(1,1)*vxi(i)+hmat(1,2)*vyi(i)+hmat(1,3)*vzi(i)
         vy(i)=hmat(2,1)*vxi(i)+hmat(2,2)*vyi(i)+hmat(2,3)*vzi(i)
         vz(i)=hmat(3,1)*vxi(i)+hmat(3,2)*vyi(i)+hmat(3,3)*vzi(i)
      enddo
c
ccccc region 4 (ir4)
c      ist = ir1 + ir2 + ir3 + 1 ; ien = ir1 + ir2 + ir3 + ir4
c      do i= ist,ien
c         vxi(i)=vxi(i)*sqrtemp_4
c         vyi(i)=vyi(i)*sqrtemp_4
c         vzi(i)=vzi(i)*sqrtemp_4
c         vx(i)=hmat(1,1)*vxi(i)+hmat(1,2)*vyi(i)+hmat(1,3)*vzi(i)
c         vy(i)=hmat(2,1)*vxi(i)+hmat(2,2)*vyi(i)+hmat(2,3)*vzi(i)
c         vz(i)=hmat(3,1)*vxi(i)+hmat(3,2)*vyi(i)+hmat(3,3)*vzi(i)
c      enddo
c
      endif
c     
c
      if (ir4.ne.0) then
ccccc  For (NVT) ensamble --- temperature scaling for substrate
c   write(6,*)'before scaling',tnw_sub,tf_sub
c  ntemp = 0 --> sqrtemp = 1.0 not scaling
c  ntemp = 1 --> sqrtemp           scaling
ccccc temperature control region  ir4
c     
c      sqrtemp0=sqrt(tf_sub/tnw_sub) 
c      sqrtemp0_3=sqrt(tf_sub/tnw(3))
c      sqrtemp_3 = real(1-ntemp) * 1.0d0 + real(ntemp) * sqrtemp0_3
c
      sqrtemp0_4=sqrt(tf_sub/tnw(4))
      sqrtemp_4 = real(1-ntemp) * 1.0d0 + real(ntemp) * sqrtemp0_4
c
c      write(6,*)'ir1',tf_sub,tnw(1)
c      write(6,*)'ir2',tf_sub,tnw(2)
c      write(6,*)'ir3',tf_sub,tnw(3)
c      write(6,*)'ir4',tf_sub,tnw(4)
c      read(5,*)
c
ccccc region 3 (ir3)
c      ist = ir1 + ir2 + 1 ; ien = ir1 + ir2 + ir3
c      do i= ist,ien
c         vxi(i)=vxi(i)*sqrtemp_3
c         vyi(i)=vyi(i)*sqrtemp_3
c         vzi(i)=vzi(i)*sqrtemp_3
c         vx(i)=hmat(1,1)*vxi(i)+hmat(1,2)*vyi(i)+hmat(1,3)*vzi(i)
c         vy(i)=hmat(2,1)*vxi(i)+hmat(2,2)*vyi(i)+hmat(2,3)*vzi(i)
c         vz(i)=hmat(3,1)*vxi(i)+hmat(3,2)*vyi(i)+hmat(3,3)*vzi(i)
c      enddo
c
ccccc region 4 (ir4)
      ist = ir1 + ir2 + ir3 + 1 ; ien = ir1 + ir2 + ir3 + ir4
      do i= ist,ien
         vxi(i)=vxi(i)*sqrtemp_4
         vyi(i)=vyi(i)*sqrtemp_4
         vzi(i)=vzi(i)*sqrtemp_4
         vx(i)=hmat(1,1)*vxi(i)+hmat(1,2)*vyi(i)+hmat(1,3)*vzi(i)
         vy(i)=hmat(2,1)*vxi(i)+hmat(2,2)*vyi(i)+hmat(2,3)*vzi(i)
         vz(i)=hmat(3,1)*vxi(i)+hmat(3,2)*vyi(i)+hmat(3,3)*vzi(i)
      enddo
c
      endif
c     
ccccccfor ramping 
c      if (mod(nstep,100).eq.0) then
c         dtf=1.0d0*boltz/ev
c         tf=tf+dtf
c      endif
c
c      ve=0
c      do 11 i=1,im
c         ve=ve+vx(i)*vx(i)+vy(i)*vy(i)+vz(i)*vz(i)
c 11   continue
c
c      tnow=ve*r3im
c      write(6,*)'after scaling',tnow*ev/boltz,tf
c
c  total enthalpy
cccc abbreviation
c     
      return
      end




