      subroutine matcal
      use work_arrays
      implicit integer (i-n)
      implicit double precision (a-h,o-z)
c      include 'para.inc'
c for matrix ( constant )
c     dimension  smat(3,3)
c for matrix ( variable )
c     dimension  hmati(3,3),hmatt(3,3),hmatti(3,3),gmat(3,3),gmati(3,3),
c    &           sigma(3,3),apst0(3,3),hmat(3,3)
c local variable
      dimension apst1(3,3),apst2(3,3)
c
ccc  det(h)
      vol=hmat(1,1)*hmat(2,2)*hmat(3,3)+hmat(1,3)*hmat(2,1)*hmat(3,2)
     &+hmat(3,1)*hmat(1,2)*hmat(2,3)-hmat(3,1)*hmat(2,2)*hmat(1,3)-
     &hmat(1,1)*hmat(3,2)*hmat(2,3)-hmat(1,2)*hmat(2,1)*hmat(3,3)
ccc  h_inverse
      hmati(1,1)=hmat(2,2)*hmat(3,3)-hmat(2,3)*hmat(3,2)
      hmati(1,2)=-hmat(1,2)*hmat(3,3)+hmat(3,2)*hmat(1,3)
      hmati(1,3)=hmat(1,2)*hmat(2,3)-hmat(1,3)*hmat(2,2)  
      hmati(2,1)=-hmat(2,1)*hmat(3,3)+hmat(3,1)*hmat(2,3)
      hmati(2,2)=hmat(1,1)*hmat(3,3)-hmat(1,3)*hmat(3,1)
      hmati(2,3)=-hmat(1,1)*hmat(2,3)+hmat(2,1)*hmat(1,3)
      hmati(3,1)=hmat(2,1)*hmat(3,2)-hmat(2,2)*hmat(3,1)
      hmati(3,2)=-hmat(1,1)*hmat(3,2)+hmat(3,1)*hmat(1,2)
      hmati(3,3)=hmat(1,1)*hmat(2,2)-hmat(2,1)*hmat(1,2)
c
      detinv=1.0d0/vol
c      
      do 10 j=1,3
         do 10 i=1,3
            hmati(i,j)=hmati(i,j)*detinv
 10   continue
ccc  hmat-transe
      hmatt(1,1)=hmat(1,1)
      hmatt(2,2)=hmat(2,2)
      hmatt(3,3)=hmat(3,3)
c
      hmatt(1,2)=hmat(2,1)
      hmatt(1,3)=hmat(3,1)
      hmatt(2,3)=hmat(3,2)
c
      hmatt(2,1)=hmat(1,2)
      hmatt(3,1)=hmat(1,3)
      hmatt(3,2)=hmat(2,3)
c
ccc  gmat
      do 30 j=1,3
      do 20 i=1,3
         gmat(j,i)=hmatt(j,1)*hmat(1,i)+hmatt(j,2)*hmat(2,i)
     &+hmatt(j,3)*hmat(3,i)
 20   continue
 30   continue
c
ccc  gmat_inverse
      gmati(1,1)=gmat(2,2)*gmat(3,3)-gmat(2,3)*gmat(3,2)
      gmati(1,2)=-gmat(1,2)*gmat(3,3)+gmat(3,2)*gmat(1,3)
      gmati(1,3)=gmat(1,2)*gmat(2,3)-gmat(1,3)*gmat(2,2)  
      gmati(2,1)=-gmat(2,1)*gmat(3,3)+gmat(3,1)*gmat(2,3)
      gmati(2,2)=gmat(1,1)*gmat(3,3)-gmat(1,3)*gmat(3,1)
      gmati(2,3)=-gmat(1,1)*gmat(2,3)+gmat(2,1)*gmat(1,3)
      gmati(3,1)=gmat(2,1)*gmat(3,2)-gmat(2,2)*gmat(3,1)
      gmati(3,2)=-gmat(1,1)*gmat(3,2)+gmat(3,1)*gmat(1,2)
      gmati(3,3)=gmat(1,1)*gmat(2,2)-gmat(2,1)*gmat(1,2)
c
      detg=gmat(1,1)*gmat(2,2)*gmat(3,3)+gmat(1,3)*gmat(2,1)*gmat(3,2)
     &+gmat(3,1)*gmat(1,2)*gmat(2,3)-gmat(3,1)*gmat(2,2)*gmat(1,3)-
     &gmat(1,1)*gmat(3,2)*gmat(2,3)-gmat(1,2)*gmat(2,1)*gmat(3,3)
c
      detginv=1.0d0/detg
c      
      do 40 j=1,3
         do 40 i=1,3
            gmati(i,j)=gmati(i,j)*detginv
 40   continue
c
ccc hmat-transe-inverse
c
      hmatti(1,1)=hmatt(2,2)*hmatt(3,3)-hmatt(2,3)*hmatt(3,2)
      hmatti(1,2)=-hmatt(1,2)*hmatt(3,3)+hmatt(3,2)*hmatt(1,3)
      hmatti(1,3)=hmatt(1,2)*hmatt(2,3)-hmatt(1,3)*hmatt(2,2)  
      hmatti(2,1)=-hmatt(2,1)*hmatt(3,3)+hmatt(3,1)*hmatt(2,3)
      hmatti(2,2)=hmatt(1,1)*hmatt(3,3)-hmatt(1,3)*hmatt(3,1)
      hmatti(2,3)=-hmatt(1,1)*hmatt(2,3)+hmatt(2,1)*hmatt(1,3)
      hmatti(3,1)=hmatt(2,1)*hmatt(3,2)-hmatt(2,2)*hmatt(3,1)
      hmatti(3,2)=-hmatt(1,1)*hmatt(3,2)+hmatt(3,1)*hmatt(1,2)
      hmatti(3,3)=hmatt(1,1)*hmatt(2,2)-hmatt(2,1)*hmatt(1,2)
c
      detinv=1.0d0/vol
c      
      do 50 j=1,3
          do 50 i=1,3
             hmatti(i,j)=hmatti(i,j)*detinv
  50   continue
c
ccc  sigma 
      do 100 j=1,3
         do 100 i=1,3
            sigma(i,j)=vol*hmatti(i,j)
 100  continue
c
           apst1(1,1)=vol*smat(1,1)
           apst1(2,2)=vol*smat(2,2)
           apst1(3,3)=vol*smat(3,3)
           apst1(1,2)=vol*smat(1,2)
           apst1(2,1)=vol*smat(2,1)
           apst1(2,3)=vol*smat(2,3)
           apst1(3,2)=vol*smat(3,2)
           apst1(1,3)=vol*smat(1,3)
           apst1(3,1)=vol*smat(3,1)
c
      do 260 j=1,3
      do 250 i=1,3
         apst2(j,i)=hmati(j,1)*apst1(1,i)+hmati(j,2)*apst1(2,i)
     &+hmati(j,3)*apst1(3,i)
 250   continue
 260   continue
c
      do 280 j=1,3
      do 270 i=1,3
        apst0(j,i)=apst2(j,1)*hmatti(1,i)+apst2(j,2)*hmatti(2,i)
     &+apst2(j,3)*hmatti(3,i)
 270   continue
 280   continue
c
ccccc check ???
c      write(88,*)'hmatt='
c      do 101 i=1,3
c         write(88,*)hmatt(i,1),hmatt(i,2),hmatt(i,3)
c 101  continue
c      write(88,*)'hmati='
c      do 102 i=1,3
c         write(88,*)hmati(i,1),hmati(i,2),hmati(i,3)
c 102  continue
c      write(88,*)'gmat='
c      do 103 i=1,3
c         write(88,*)gmat(i,1),gmat(i,2),gmat(i,3)
c 103  continue
c      write(88,*)'gmati='
c      do 104 i=1,3
c         write(88,*)gmati(i,1),gmati(i,2),gmati(i,3)
c 104  continue
c      write(88,*)'vgmat='
c      do 105 i=1,3
c         write(88,*)vgmat(i,1),vgmat(i,2),vgmat(i,3)
c 105  continue
ccccccccccccccc
      return
      end







